package com.cqut.stack.bn.service.impl;

import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.cqut.stack.bn.pojo.dto.hotlineDailyAcceptance.DateDTO;
import com.cqut.stack.bn.pojo.dto.hotlineDeptAcceptance.GetHotlineDeptAcceptanceDTO;
import com.cqut.stack.bn.pojo.entity.DistrictHandle;
import com.cqut.stack.bn.service.DistrictHandleService;
import com.cqut.stack.bn.dao.DistrictHandleMapper;
import com.github.pagehelper.PageHelper;
import org.springframework.stereotype.Service;

import java.util.List;

/**
* @author thinkpad
* @description 针对表【district_handle(区县受理量、交办量)】的数据库操作Service实现
* @createDate 2024-11-24 15:53:46
*/
@Service
public class DistrictHandleServiceImpl extends ServiceImpl<DistrictHandleMapper, DistrictHandle>
    implements DistrictHandleService{

    @Override
    public List<DistrictHandle> getDistrictHandle(DateDTO dateDTO) {
        LambdaQueryWrapper<DistrictHandle> queryWrapper = new LambdaQueryWrapper<>();
        if(dateDTO.getStartDate()!=null)
            queryWrapper.ge(DistrictHandle::getStatDate,dateDTO.getStartDate());
        if(dateDTO.getEndDate()!=null)
            queryWrapper.le(DistrictHandle::getStatDate,dateDTO.getEndDate());
        PageHelper.startPage(dateDTO.getPageNum(),dateDTO.getPageSize());
        return this.list(queryWrapper);
    }
}




