package com.cqut.stack.bn.service.impl;

import cn.hutool.core.collection.CollectionUtil;
import cn.hutool.core.util.ObjectUtil;
import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import com.cqut.stack.bn.pojo.dto.hotlineAcceptance.GetCurrentAreaHotlineAcceptanceDTO;
import com.cqut.stack.bn.pojo.dto.hotlineDeptAcceptance.GetHotlineDeptAcceptanceDTO;
import com.cqut.stack.bn.pojo.entity.HotlineAcceptance;
import com.cqut.stack.bn.dao.HotlineAcceptanceMapper;
import com.cqut.stack.bn.service.HotlineAcceptanceService;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.github.pagehelper.PageHelper;
import org.springframework.stereotype.Service;

import java.util.List;

@Service
public class HotlineAcceptanceServiceImpl extends ServiceImpl<HotlineAcceptanceMapper, HotlineAcceptance> implements HotlineAcceptanceService {

    @Override
    public List<HotlineAcceptance> getCurrentAreaHotlineAcceptance(GetCurrentAreaHotlineAcceptanceDTO dto) {
        LambdaQueryWrapper<HotlineAcceptance> queryWrapper = Wrappers.lambdaQuery();
        queryWrapper.eq(ObjectUtil.isNotEmpty(dto.getYear()),HotlineAcceptance::getStatDate,dto.getYear());
        List<HotlineAcceptance> list = this.list(queryWrapper);
        return list;
    }

    @Override
    public List<HotlineAcceptance> getHotlineAcceptance(GetHotlineDeptAcceptanceDTO getHotlineDeptAcceptanceDTO) {
        LambdaQueryWrapper<HotlineAcceptance> queryWrapper = new LambdaQueryWrapper<>();
        if(getHotlineDeptAcceptanceDTO.getStartYear() != null)
            queryWrapper.ge(HotlineAcceptance::getStatDate,getHotlineDeptAcceptanceDTO.getStartYear());
        if(getHotlineDeptAcceptanceDTO.getEndYear() != null)
            queryWrapper.le(HotlineAcceptance::getStatDate,getHotlineDeptAcceptanceDTO.getEndYear());
        PageHelper.startPage(getHotlineDeptAcceptanceDTO.getPageNum(),getHotlineDeptAcceptanceDTO.getPageSize());
        return this.list(queryWrapper);
    }
}
