package com.cqut.stack.bn.service.impl;

import cn.hutool.core.bean.BeanUtil;
import cn.hutool.core.collection.CollectionUtil;
import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import com.cqut.stack.bn.pojo.dto.hotlineDailyAcceptance.DateDTO;
import com.cqut.stack.bn.pojo.entity.TodayAcceptance;
import com.cqut.stack.bn.dao.TodayAcceptanceMapper;
import com.cqut.stack.bn.pojo.vo.todayAcceptance.GetTodayAcceptanceInfoVO;
import com.cqut.stack.bn.service.TodayAcceptanceService;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.github.pagehelper.PageHelper;
import org.springframework.stereotype.Service;

import java.time.LocalDate;
import java.util.List;

@Service
public class TodayAcceptanceServiceImpl extends ServiceImpl<TodayAcceptanceMapper, TodayAcceptance> implements TodayAcceptanceService {

    @Override
    public GetTodayAcceptanceInfoVO getTodayAcceptanceInfo() {
        LambdaQueryWrapper<TodayAcceptance> queryWrapper = Wrappers.lambdaQuery();
        queryWrapper.eq(TodayAcceptance::getStatDate, LocalDate.now());
        GetTodayAcceptanceInfoVO getTodayAcceptanceInfoVO = new GetTodayAcceptanceInfoVO();
        List<TodayAcceptance> todayAcceptanceList = this.list(queryWrapper);
        if(CollectionUtil.isEmpty(todayAcceptanceList))
            return null;
        BeanUtil.copyProperties(todayAcceptanceList.get(0),getTodayAcceptanceInfoVO);
        return getTodayAcceptanceInfoVO;
    }

    @Override
    public List<TodayAcceptance> getTodayAcceptance(DateDTO dateDTO) {
        LambdaQueryWrapper<TodayAcceptance> queryWrapper = Wrappers.lambdaQuery();
        if(dateDTO.getStartDate()!=null)
            queryWrapper.ge(TodayAcceptance::getStatDate,dateDTO.getStartDate());
        if(dateDTO.getEndDate()!=null)
            queryWrapper.le(TodayAcceptance::getStatDate,dateDTO.getEndDate());
        PageHelper.startPage(dateDTO.getPageNum(),dateDTO.getPageSize());
        return this.list(queryWrapper);
    }
}
